
        $MOD52

;****************************************************************************
;
;                             EQUATE FOR SYSTEM
;
;****************************************************************************
EnableTimer50ms EQU     0       ; FLAG: Timer 0 count
Count50ms       EQU     30h     ; 50ms tick counter
SQUELCH         EQU     P1.0    ; Squelch input
PTT             EQU     P1.1    ; PTT output

;****************************************************************************
;
;                           INTERRUPT VECTOR TABLE
;
;****************************************************************************

        ORG     0000h
        LJMP    start                   ; Go to program start

        org     0003h                   ; INT0 vector, real time clock (80C51)
        RETI

        org     000Bh                   ; Timer #0 not used, packet timing
        JMP     T0int

        org     0013h                   ; INT1 vector, wake-up from IDLE mode
        RETI

        org     001Bh                   ; timer #1, serial baud rate, not used
        RETI

        org     0023h                   ; Serial port interrupt
        RETI

        org     002Bh                   ; TIMER #2, real time clock (80C52)
        RETI

;****************************************************************************
;
;                               INTERRUPT DRIVER
;
;****************************************************************************
T0int:  MOV     TL0,#00h
        MOV     TH0,#04Ch       ; 50ms interval

        JNB     EnableTimer50ms,EndI
        MOV     a,Count50ms
        JZ      EndI
        DEC     Count50ms
EndI:   RETI

;****************************************************************************
;
;                                  START POINT
;
;****************************************************************************
Start:  SETB    EA              ; enable all interrupt
        MOV     a,TMOD          ; Timer #0 programmation
        ANL     a,#0F0h
        ORL     a,#01h          ; Set timer #0 16 bit mode
        MOV     TMOD,a             
        MOV     TL0,#00h
        MOV     TH0,#04Ch       ; 50ms interval
        SETB    ET0             ; Enable interrupt
        SETB    TR0             ; Start timer

        SETB    EnableTimer50ms ; Start timer

L0:     SETB    PTT
        MOV     Count50ms,#20   ; Reset counter
L1:     JNB     Squelch,L0      ; Squelch = 0, PBO placotte
        MOV     a,Count50ms
        JNZ     L1 
        CLR     PTT
        JMP     L1       

        END